<body id="page-top">
<div id="wrapper">
  <app-home-application></app-home-application>
  <div class="d-flex flex-column" id="content-wrapper">
    <div id="content">
      <app-navbar></app-navbar>

      <div class="container my-auto">
        <div class="container" *ngIf="ticket">
          <main>
            <div class="py-5 text-center">
              <h2>Demande n°{{ ticket.id }}</h2>
              <h3>{{ticket.status}}</h3>
            </div>

            <div class="row g-5">
              <div class="col-md-5 col-lg-4 order-md-last">
                <h4 class="d-flex justify-content-between align-items-center mb-3">
                  <span class="text-primary">Participants</span>
                  <span class="badge bg-primary rounded-pill">{{participants.length}}</span>
                </h4>
                <ul class="list-group mb-3">
                  <li class="list-group-item d-flex justify-content-between lh-sm"
                      [ngClass]="{
                       'bg-success text-white': participant.status === 'Validé',
                       'bg-danger' : participant.status === 'Refusé',
                       'bg-warning' : participant.status === 'En attente' }" *ngFor="let participant of participants">
                      <div>
                        <h6 class="my-0">{{participant.firstName}} {{participant.lastName}}</h6>
                        <small>{{ participant.role }}</small>
                      </div>
                      <span>{{ participant.status }}</span>
                      <button type="button" class="btn btn-danger" *ngIf="isOwner" (click)="removeParticipant(participant.userId)">X</button>

                  </li>
                </ul>

                <form class="card p-2"  *ngIf="isOwner">
                  <div class="input-group">
                    <input type="text" class="form-control" id="participant" name="participant" placeholder="Nom prénom" [(ngModel)]="searchText">
                    <div class="autocomplete-items" *ngIf="searchText.length">
                      <div class="d-flex justify-content-between" *ngFor="let user of users | usersFilter: searchText">
                        {{user.firstName}} {{user.lastName}}
                        <button type="submit" class="btn btn-success text-white" (click)="addParticipant(user.id)">Ajouter</button>
                      </div>
                    </div>
                  </div>
                </form>

                <div class="mt-5">
                  <h4 class="d-flex justify-content-between align-items-center">
                    <span class="text-primary">Fichier</span>
                  </h4>
                  <form class="card mt-2 p-2">
                    <div class="input-group">
                      <input type="file" class="form-control" id="customFile" onchange="console.log(target.files)">
                    </div>
                  </form>
                </div>

                <div class="mt-5">
                  <h4 class="d-flex justify-content-between align-items-center">
                    <span class="text-primary">Commentaires</span>
                  </h4>
                  <button class="w-100 btn btn-outline-primary btn-lg" (click)="openCommentShow(longContent)" type="button">Voir les commentaires</button>
                </div>
              </div>

              <div class="col-md-7 col-lg-8">
                <form class="needs-validation" [formGroup]="ticketForm" (ngSubmit)="onSubmit()" novalidate>
                  <div class="col-sm-12">

                    <div *ngIf="isOwner">
                      <input type="text" formControlName="title" class="form-control mt-2"
                            [ngClass]="{ 'is-invalid': submitted && f.title.errors }"
                            required>
                    </div>
                    <div *ngIf="!isOwner">
                      <input type="text" class="form-control" formControlName="title" placeholder="Titre" value="{{ ticket.title }}" readonly>
                    </div>
                    <div class="invalid-feedback">
                      Valid last name is required.
                    </div>
                  </div>

                  <div class="row g-3">
                    <div class="col-sm-12">
                      <div *ngIf="isOwner">
                        <textarea type="text" class="form-control mt-3" formControlName="description" rows="14"
                                  [ngClass]="{ 'is-invalid': submitted && f.description.errors }"></textarea>
                      </div>
                      <div *ngIf="!isOwner">
                        <textarea type="text" class="form-control mt-3" formControlName="description" rows="14" readonly></textarea>
                      </div>
                      <div class="invalid-feedback">
                        Valid first name is required.
                      </div>
                    </div>

                    <div class="col-12">
                      <label for="start">Date butoir :</label> <br>
                      <div *ngIf="isOwner">
                        <input type="date" id="start" formControlName="endDate" value="{{ ticket.endDate }}">
                      </div>
                      <div *ngIf="!isOwner">
                        <p>{{ ticket.endDate }}</p>
                      </div>
                    </div>
                  </div>

                  <hr class="my-4">
                  <div *ngIf='ticket.status === "En attente"'>
                    <div *ngIf="isOwner" class="text-center">
                      <button class="btn btn-info btn-lg m-1 text-white"  (click)="openCommentForm(content)" type="button">Commenter</button>
                      <button class="btn btn-primary btn-lg m-1" type="submit"  [disabled]="!isUpdatable">Modifier</button>
                      <button class="btn btn-danger btn-lg m-1 text-white"  (click)="deleteTicket()" type="button">Supprimer</button>
                    </div>
                    <div *ngIf="!isOwner" class="text-center">
                      <button class="btn btn-info btn-lg m-1 text-white"  (click)="openCommentForm(content)" type="button" >Commenter</button>
                      <button class="btn btn-success btn-lg m-1 text-white" type="button" (click)="changeParticipantStatus('Approved')">Approuver</button>
                      <button class="btn btn-danger btn-lg m-1 text-white" type="button" (click)="changeParticipantStatus('Refused')" >Refuser</button>
                    </div>
                  </div>

                  <div *ngIf='ticket.status !== "En attente"'>
                    <div *ngIf="isOwner">
                      <button class="w-100 btn btn-primary btn-lg mb-4"  [disabled]="!isUpdatable" type="submit">Modifier</button>
                    </div>
                  </div>

                </form>

              </div>
            </div>
          </main>
        </div>
      </div>
    </div>
  </div>
</div>

<!-- Add comment -->
<ng-template #content let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-basic-title">Ajout d'un commentaire</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss()">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <form #data (ngSubmit)="saveComment(data)">
      <div class="form-group">
        <label for="comment">Commentaire</label>
        <div class="input-group">
          <textarea id="comment" class="form-control"></textarea>
        </div>
      </div>
      <button type="submit" class="btn btn-outline-success" (click)="modal.close()">Envoyer</button>
    </form>
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-outline-dark" (click)="modal.close()">Annuler</button>
  </div>
</ng-template>

<!-- See comment -->
<ng-template #longContent let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-basic-title2">Commentaires</h4>

  </div>
  <div class="modal-body">
   <div *ngFor="let commentary of commentaries">
     <p>{{commentary.text}}</p>
     <p class="text-right commentary">{{commentary.lastName}} {{commentary.firstName}} Le {{commentary.sendingDate}}</p>
     <hr class="my-2">
   </div>
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-outline-dark" (click)="modal.close('Save click')">Fermer</button>
  </div>
</ng-template>
</body>

